unit FData;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids;

type
  TFormData = class(TForm)
    DBGridData: TDBGrid;
    DataSource: TDataSource;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FDS:TDataSet;
    procedure SetDS(const Value: TDataset);
  public
    property DS:TDataset read FDS write SetDS;
  end;

var
  FormData: TFormData;

implementation

{$R *.dfm}

procedure TFormData.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  // Asignado el Dataset? lo liberamos
  if Assigned(FDS) then begin
    FreeAndNil(FDS);
  end;

  Action := caFree;

end;

procedure TFormData.SetDS(const Value: TDataset);
begin
  FDS := Value;
  Self.DataSource.DataSet := Value;
end;

end.
